/*
 * login_search_click_scenario2.js
 * 
 * by: Piotr Sapiezynski
 * 
 * Goal: Logs in to google account, performs a number of searches for given keywords and clicks on chosen links
 * 
 * Usage:
 * phantomjs login_search_click_scenario2.js --username=[] --password=[] --keyword-file=[] --click-file=[] --output=[]
 * 
 * Example:
 * phantomjs login_browse.js --username=kakhkation --password=kheilikhari --keyword-file=url --click-file=Dir_Test --ouput=results
 * 
 * optional flags:
 *    --page_limit:   number of clicks within a domain before going to the next url
 *    --retry_limit:  number of retrys before skipping, DEFAULT: 3
 *    --sleep_page :  sleep time (ms) between clicks within a domain, DEFAUL: 5000
 *    --sleep_query:  sleep time (ms) between queries, DEFAUL: 5000
 *    --sleep_retry:  sleep time (ms) between retries, DEFAUL: 5000
 *    --status_file:  file that stores the latest url_term_index
 *    --user-agent:   sets the user-agent, DEFAULT: "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/536.6 (KHTML, like Gecko) Chrome/20.0.1132.57 Safari/536.6"
 */var DEBUG  = 1;
var page = require('webpage').create();
var fs = require('fs');
var system = require('system');

system.search_terms = [];
system.click_urls = [];
system.search_term_index = -1;
system.page_index = 0;

system.page_limit = 1;
system.sleep_page = 5000; //5000;
system.sleep_error = 5000; //5000;
system.sleep_query = 15000;
system.login         = 1;
system.clear_cookies = 0;

IE6_On = 0;
FirstAfterLogin = 1;

page.settings.userAgent = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
page.customHeaders = {"Accept-Language":"en"};

system.args.forEach(function (arg, i) {
    parts = arg.split("=");
    if (parts[0] == '--username') {
  system.username = parts[1];
    } else if (parts[0] == '--password') {
  system.password = parts[1];
    } else if (parts[0] == '--keyword') {
  system.search_terms[0] = parts[1];
    } else if (parts[0] == '--no_login') {
        system.login = 0;
    } else if (parts[0] == '--clear_cookies') {
        system.clear_cookies = 1;
    } else if (parts[0] == '--keyword-file') {
    try {
      f = fs.open(parts[1], "r");
      while (line = f.readLine())
      system.search_terms.push(line.replace("\n", ""));

      f.close();
      log('no of Search terms: ' + system.search_terms.length);
    } catch (e) {
      die_with_error("Error reading keywords from '" + parts[1] + "': " + e);
    }
    } else if (parts[0] == '--click-file') {
            try {
                f = fs.open(parts[1], "r");
                while (line = f.readLine()) {
                    system.click_urls.push(line.replace("\n", ""));
          log('Will click on: ' + line);
        }
      
                f.close();
            } catch (e) {
                die_with_error("Error reading urls from '" + parts[1] + "': " + e);
            }
  }else if (parts[0] == '--output') {
    system.target_dir = parts[1];
    checkDirectory(system.target_dir);
    } else if (parts[0] == '--page_limit') {
    system.page_limit = parseInt(parts[1]);
    } else if (parts[0] == '--sleep_page') {
    system.sleep_page = parts[1];
    } else if (parts[0] == '--sleep_query') {
    system.sleep_query = parts[1];
    } else if (parts[0] == '--user-agent') {
    if (parts[1] == 'default') {
      page.settings.userAgent = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'xp') {
      page.settings.userAgent = "Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'win7') {
      page.settings.userAgent = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'osx') { 
      page.settings.userAgent = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_8_2) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'linux') {
      page.settings.userAgent = "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'android') {
      page.settings.userAgent = "Mozilla/5.0 (Linux; Android 4.1.1; Nexus S Build/JRO03E) AppleWebKit/535.19 (KHTML, like Gecko) Chrome/18.0.1025.166 Mobile Safari/535.19";
      } else if (parts[1] == 'ios') {
      page.settings.userAgent = "Mozilla/5.0 (iPhone; U; CPU iPhone OS 5_1_1 like Mac OS X; en-us) AppleWebKit/534.46.0 (KHTML, like Gecko) CriOS/19.0.1084.60 Mobile/9B206 Safari/7534.48.3";
      } else if (parts[1] == 'ie6') {
        IE6_On = 1;
        page.settings.userAgent = "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; .NET CLR 2.0.50727)";
      } else if (parts[1] == 'ie8') {
      page.settings.userAgent = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)";
      } else if (parts[1] == 'chrome') {
      page.settings.userAgent = "Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.2 (KHTML, like Gecko) Chrome/22.0.1216.0 Safari/537.2";
      } else if (parts[1] == 'firefox') {
      page.settings.userAgent = "Mozilla/5.0 (Windows NT 6.1; rv:15.0) Gecko/20100101 Firefox/15.0.1";
      } else if (parts[1] == 'safari') {
      page.settings.userAgent = "Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US) AppleWebKit/537.13+ (KHTML, like Gecko) Version/5.1.7 Safari/534.57.2";
      } 
    }
    else if (parts[0] == '--status_file'){
      system.status_file = parts[1];
      f = fs.open(system.status_file, "r");
    line = f.readLine();
    system.search_term_index = parseInt(line.replace("\n", ""));
    f.close();
  }
  
});

last_num  = null;
last_fun  = null;
last_next = null;

/**
 * safe way to create a directory
 * @param dir - path and name of the directory to create
 */
function checkDirectory(dir) {
  try {
    if (! fs.exists(dir))
      fs.makeDirectory(system.target_dir);
  } catch (e) {
    die_with_error("Could not create directory '" + dir + "': " + e);
  }
  
  if (! fs.isDirectory(system.target_dir))
    die_with_error("Could not create directory '" + dir + "': Exists as a file.");
}

/**
 * Logs a message to console together with date and time
 * @param msg
 */
function log(msg) {
  console.log((new Date().getTime()) + ": " + msg);
}

/**
 * finds results on the page and saves them to txt file. Does not regognize local/video boxes and so on,
 * use google.py for fool-proof parsing
 * @param alist
 */
function log_urls(alist) {
  f = fs.open(system.target_dir + "/" + system.search_terms[system.search_term_index].replace(" ", "+") + ".txt", "a");
  
  for (var i = 0; i < alist.length; i++)
    f.writeLine((system.page_index*10 + i) + "\t" + alist[i]);
  
  f.close();
}

/**
 * drops the content of the webpage to .html file and renders the graphical representation to .png file
 * @param content
 */
function log_html(content) {
  page.render(system.target_dir + "/" + system.search_terms[system.search_term_index].replace(" ", "+") + "." + system.page_index + ".png");
  f = fs.open(system.target_dir + "/" + system.search_terms[system.search_term_index].replace(" ", "+") + "." + system.page_index + ".html", "a");
  f.writeLine(content);
  f.close();
}

/**
 * logs the position and url of the clicked result and whether Google registered this clicking
 * @param link
 * @param id
 */
function log_clicked(link, id) {
  f = fs.open(system.target_dir + "/" + system.search_terms[system.search_term_index].replace(" ", "+") + "_clicked_link.txt", "a");

    f.writeLine(id + "\t" + link);

  f.close();
}


/**
 * ran when the page is loaded succesfully
 * @param status
 */
function load_finished(status) {
  var prev_load_finished = page.load_finished;
  page.load_finished = null;
  
  if (prev_load_finished !== null)
    prev_load_finished(status);
}

/**
 * logs a message and dies
 * @param message
 */
function die_with_error(message) {
  log(message);
  page.render('before_dying.png');
//  log(page.content);
  phantom.exit();
}

/**
 * goes to next page
 * @param num
 * @param fun
 * @param next
 */
function next_page(num, fun, next) {
    if (system.clear_cookies) phantom.clearCookies();

    interval = setInterval(function() {
        page.load_finished = next;
        clearInterval(interval);
                         
        last_num = num;
        last_fun = fun;
        last_next = next;
        console.log('fun: ' + fun);
        eval("function step() { " + fun + " return 1; }");
        if (! page.evaluate(step))
            die_with_error("Unable to execute function '" + fun + "'");
    }, system.sleep_page);
}

/**
 * reruns the search if failed, does nothing otherwise
 * @param num
 * @param status
 */
function check_page(num, status) {
  if (DEBUG)
    log("===============> STEP " + num + " (" + system.search_terms[system.search_term_index] + " page " + system.page_index + ") <===============");
  
  if (status !== 'success') {
      log("Error in step " + num + ": " + status + " (" + system.search_terms[system.search_term_index] + " page " + system.page_index + ") <===============");
      log("Sleeping and retrying...");
      interval = setInterval(function() {
      clearInterval(interval);
      next_page(last_num, last_fun, last_next);
      }, system.sleep_error);
  }
  if (! page.injectJs("jquery-1.7.2.js"))
    die_with_error("Error injecting Jquery");
}

/**
 * saves the page to html and png files, then either goes to the next page with results or searches for next item on the list
 * @param status
 */
function get_results(status) {
  check_page(3, status);

  log_html(page.content);
  log_urls(page.evaluate(function() { return Array.prototype.map.call(document.querySelectorAll('h3.r >a.l'), function(a) { return a.href; }); }));

  system.page_index++;
  if (!click_result(status)) {
    if (system.page_index < system.page_limit){
      if (IE6_On == 0)
        next_page(3, "document.location.href=document.getElementById('pnnext').href;", get_results);
      
      else if (IE6_On == 1){
        var Dhref = page.evaluate(function() { return $('#nav td[style="text-align:left"] a[class!=""]').attr('href'); });
        var Dhost = page.evaluate(function() { return window.location.host; });
        var Dprot = page.evaluate(function() { return window.location.protocol; });
        var Dredirect = Dprot + '//' + Dhost + Dhref;
        next_page(3, "document.location.href=\""+Dredirect+"\";", get_results);
      }
    }
    else
      interval = setInterval(function() { clearInterval(interval); search(status); }, system.sleep_query);
  }
}

/**
 * Runs the google search
 * @param status
 */
function search(status) {
    check_page(2, status);

    //To take care of "Please set up your recovery options"
  if (page.evaluate(function() { return (document.getElementById('save') !== null); })) {
      console.log("Clicking on 'Save and continue'");
      next_page(2, "document.getElementById('save').click();", search);
  }
    
    else{
      system.page_index = 0;
      system.search_term_index++;
      f = fs.open(system.status_file, "w");
      f.writeLine(system.search_term_index.toString());
      f.close();
      
      if (system.search_term_index < system.search_terms.length) {
      if (IE6_On == 0){
          if (page.evaluate(function() { return (document.getElementById('gbqfq') !== null); })) {
          page.evaluate(function(str) { $('input[name=q]').val(str); }, system.search_terms[system.search_term_index]);
          next_page(2, "document.getElementById('gbqf').submit();", get_results);
          }
          else{
            system.search_term_index--;
        prepare_for_search(status);
        //die_with_error("Could not find search box");
        }
      }
      else if (IE6_On == 1){
          console.log('IE6 is on!');
          if (page.evaluate(function() { return ($('input[name="q"]') !== null); })) {
          console.log(system.search_terms[system.search_term_index]);
          page.evaluate(function(str) { $('input[name="q"]').val(str); }, system.search_terms[system.search_term_index]);
          if (FirstAfterLogin == 1){
              FirstAfterLogin = 0;
              next_page(2, "$('input[name=\"btnG\"]').click();", get_results);
          }
          else
              next_page(2, "$('button[name=\"btnG\"]').click();", get_results);
          }
          else{
                                system.search_term_index--;
                                prepare_for_search(status);
                                //die_with_error("Could not find search box");
                                }
      }
      }
      
      else {
        log("Done with all search terms -- exiting");
        phantom.exit();
      }
    }
}

/**
 * Logs in to google account
 * @param status
 */
function do_login(status) {
  check_page(1, status);
  
  if (page.evaluate(function() { return (document.getElementById('Email') !== null); })) {
    page.evaluate(function(user, pass) { $('#gaia_loginform input#Email').val(user); $('#gaia_loginform input#Passwd').val(pass); }, system.username, system.password);
    
    next_page(1, "$('#gaia_loginform input#signIn').click();", search);
  } else {
    die_with_error("Could not find login form");
  }
}

//functions for clicking:
//1. Returns true if the given string is in the array
function is_in(string, arr) {
    for (i = 0; i < arr.length; i++)
        if (arr[i] == string)
            return true;
    return false;
}

// Returns true is the given string is a substring of any string in the array
function is_part_of(string, arr) {
  for (i = 0; i < arr.length; i++)
    if (string.indexOf(arr[i]) > -1)
      return true;
  return false;
}

/**
 * Clicks a result in a way that let's google know that a result was chosen
 * @param status
 * @returns {Boolean}
 */
function click_result(status) {
    check_page(3, status);

    log_html(page.content);
  var parse_result = page.evaluate(function() {
    var dispatchMouseEvent = function(target, var_args) {
      var e = document.createEvent("MouseEvents");
      e.initEvent.apply(e, Array.prototype.slice.call(arguments, 1));
      target.dispatchEvent(e);
    };
    var a = document.getElementById("pnnext");//, alist = [];
    aurl = a.href;
    var a = document.querySelectorAll('h3.r >a.l'), alist = [], a_clicklist = [];
    for (var i = 0; i < a.length; i++) 
      if (a[i].href) {
        alist.push(a[i].href);
        unchanged = a[i].href;
        dispatchMouseEvent(a[i], 'mousedown', true, false);
        if (unchanged == a[i].href) {
          console.log('google did not exchange the original url with the redirect url!');
        }
        a_clicklist.push(a[i].href);
    
      }

    return {aurl: aurl, results: alist, redirect_results: a_clicklist};   

  })
    for (var i = 0; i < parse_result.results.length; i++) {
    if (is_part_of(parse_result.results[i], system.click_urls)) {
      log("Clicking on: " + parse_result.results[i]);
      log("Going to: " + parse_result.redirect_results[i]);
      log_clicked(parse_result.results[i], (system.page_index-1)*10 + i); 
      eval("function open_link() { document.location.href='" + parse_result.redirect_results[i] + "';}");
      page.evaluate(open_link);
      interval = setInterval(function() { clearInterval(interval); prepare_for_search(status); }, system.sleep_query*4/5);
      return true;
    }
  }
  
  return false;
}

/**
 * Intermediate function ran in case of error
 * @param status
 */
function prepare_for_search(status) {
  page.render('dummy.png');
  eval("function go_to_google() { document.location.href='https://www.google.com';}");
  page.evaluate(go_to_google);
  interval = setInterval(function() { clearInterval(interval); search(status); }, system.sleep_query/5);
}


//page.onResourceRequested = function(req) { if (req.url.substring(0,4) == "http") log("REQ: " + req.url) };

if (system.login) {
    page.load_finished = do_login;
    page.onLoadFinished = load_finished;
    page.open("https://accounts.google.com/ServiceLogin?hl=en&continue=https://www.google.com/");
}
else {
    page.load_finished = search;
    page.onLoadFinished = load_finished;
    page.open("https://www.google.com/");    
}